﻿using Kivii.Lims.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Lac.Lims.Transforms
{
    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateFileCreate : RestfulCreate<TemplateFile>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateFileRead : RestfulRead<TemplateFile>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateFileUpdate : RestfulUpdate<TemplateFile>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateFileDelete : RestfulDelete<TemplateFile>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateFileQuery : RestfulQuery<TemplateFile>
    { }
}
