﻿using Kivii;
using Kivii.Lims.Entities;
using Kivii.Lac.Lims.Extensions;
using Kivii.Linq;
using Kivii.Linq.Legacy;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace Kivii.Lac.Lims.Transforms
{
    #region CQ
    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    [Api(Description = "查询")]
    public class TestQuery : RestfulQuery<Test>
    { }

    /// <summary>
    /// 创建Test时更新对应Report中的实测值字段
    /// </summary>
    //[RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    //[Api(Description = "创建")]
    //public class TestCreate : RestfulCreate<Test>
    //{
    //    public Guid ReportItemKvid { get; set; }
    //    public override bool OnPreRestfulCreate(IRequest req, IResponse res, IDbConnection dbConnection, IRestfulCreateResponse<Test> rtns)
    //    {
    //        var reportItem = dbConnection.SingleById<ReportItem>(ReportItemKvid);
    //        reportItem.ThrowIfNull("未找到检测项！");
    //        Item.Kvid = Guid.NewGuid();
    //        Item.AddOnlyProperties(o => o.Kvid);
    //        Item.RootKvid = Item.Kvid;
    //        if (reportItem.TestKvid != Guid.Empty)
    //        {
    //            var originalTest = dbConnection.SingleById<Test>(reportItem.TestKvid);
    //            if (originalTest == null) throw new Exception("数据异常，未找到源检验数据！");
    //            Item.RootKvid = originalTest.RootKvid;
    //        }
    //        Item.AddOnlyProperties(o => o.RootKvid);
    //        Item.SampleKvid = reportItem.SampleKvid;
    //        Item.AddOnlyProperties(o => o.SampleKvid);
    //        Item.SampleRootKvid = reportItem.SampleRootKvid;
    //        Item.AddOnlyProperties(o => o.SampleRootKvid);
    //        return base.OnPreRestfulCreate(req, res, dbConnection, rtns);
    //    }
    //    public override bool OnPostRestfulCreate(IRequest req, IResponse res, IDbConnection dbConnection, IRestfulCreateResponse<Test> rtns)
    //    {
    //        var reportItem = dbConnection.SingleById<ReportItem>(ReportItemKvid);
    //        var currentTest = rtns.Results.FirstOrDefault();
    //        reportItem.TestKvid = currentTest.Kvid;
    //        reportItem.TestRootKvid = currentTest.RootKvid;
    //        reportItem.TestCreateTime = currentTest.CreateTime;
    //        reportItem.TestCreatorKvid = currentTest.CreatorKvid;
    //        reportItem.TestCreatorName = currentTest.CreatorName;
    //        reportItem.TestValue = currentTest.Value;
    //        reportItem.StatusType = ReportItemStatusType.BeforeReview;
    //        reportItem.AddOnlyProperties(o => new { o.TestKvid, o.TestRootKvid, o.TestCreateTime, o.TestCreatorKvid, o.TestCreatorName, o.TestValue, o.Status });
    //        dbConnection.UpdateOnly(reportItem);
    //        return base.OnPostRestfulCreate(req, res, dbConnection, rtns);
    //    }
    //}

    #endregion

    #region <待重写，99>根据某一条Test生成复测记录
    //[RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    //[Api(Description = "生成复测")]
    //public class TestRepeat : RestfulExecution<Test>
    //{
    //    private IDbTransaction _trans;
    //    public List<Guid> TestKvids { get; set; }
    //    public Guid ReportKvid { get; set; }
    //    public override object OnExecution(IRequest req, IResponse res)
    //    {
    //        var conn = KiviiContext.GetOpenedDbConnection<Test>();
    //        var queryTest = conn.From<Test>();
    //        queryTest.Where(o => Sql.In(o.Kvid, TestKvids));
    //        var reTests = conn.Select(queryTest);
    //        if (reTests.Exists(o => o.Type != TestType.Test)) throw new Exception("待复测项存在类型为非检验项类型，无法复测！");
    //        if (reTests.Exists(o => o.ValueTested == null || o.ValueTested == string.Empty)) throw new Exception("存在无实测值的待复测项，无法复测！");
    //        _trans = conn.OpenTransaction();
    //        var response = new RestfulCreateResponse<Test>();
    //        response.Results = new List<Test>();
    //        foreach (var reTest in reTests)
    //        {
    //            //生成复测项目
    //            var newTest = new Test();
    //            newTest.PopulateWith(reTest);
    //            newTest.Kvid = Guid.NewGuid();
    //            newTest.ValueTested = string.Empty;
    //            newTest.Type = TestType.ReTest;

    //            conn.Insert(newTest);


    //            response.Results.Add(newTest);

    //            //在ReportJudgement中创建对应关系
    //            var reportJudgement = new ReportJudgement();
    //            reportJudgement.ReportKvid = ReportKvid;
    //            reportJudgement.TestKvid = newTest.Kvid;
    //            reportJudgement.ValueUnit = newTest.ValueUnit;
    //            reportJudgement.ValueQualified = newTest.ValueQualified;
    //            conn.Insert(reportJudgement);
    //        }

    //        _trans?.Commit();

    //        return response;
    //    }
    //}
    #endregion
}


