﻿using Kivii.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Lims
{
    internal class Configs
    {
        //------------数据库表名称
        public const string TableNameReport = "LIMS_Reports";
        public const string TableNameReportFile = "LIMS_ReportFiles";
        public const string TableNameReportHistory = "LIMS_Reports_History";
        public const string TableNameReportItem = "LIMS_ReportItems";
        public const string TableNameReportItemHistory = "LIMS_ReportItems_History";
        public const string TableNameReportJudgement = "LIMS_ReportJudgements";
        public const string TableNameTest = "LIMS_Tests";
        public const string TableNameTestHistory = "LIMS_Tests_History";
        public const string TableNameSample = "LIMS_Samples";
        public const string TableNameTemplate = "LIMS_Templates";
        public const string TableNameTemplateFile = "LIMS_TemplateFiles";
        public const string TableNameSampleSource = "LIMS_SampleSources";
        public const string TableNameTemplateDetail = "LIMS_TemplateDetails";

        public const string TableNameReportNote = "LIMS_ReportNotes";
        public const string TableNameReportChange = "LIMS_ReportChanges";

        public const string TableNameThirdReportOrder = "LIMS_ThirdReportOrders";
        public const string TableNameThirdReportOrderDetail = "LIMS_ThirdReportOrderDetails";

        public const string TableNameB2bLink = "LIMS_B2bLinks";
        //public const string TableNameSampleSource = "LIMS_SampleSource";

        public const string RouteLimsReportRead = "/Lims/ReportRead";

        public const string RouteReportPdf = "/Lims/Report/{Code}/{ReportId}";
        public const string RouteReportGenerateSourcePath = "/Report/Excel";
        public const string RouteReportGenerateCombineSourcePath = "/Report/Excel01";
        public const string RouteReportSampleFilePath = "/Samples/Images";

        public static List<string> JudgementNoPassResults = new List<string> { "不合格", "不符合", "抗沾湿性能较差", "抗沾湿性能差", "不具有抗沾湿性能", "抗勾丝性能差", "抗静水压性能差", "抗静电性能差" };

        public static ILog Logger { get; } = LogManager.GetLogger("Kivii.Lac.Lims");


    }
}
