﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Lac.Lims
{
    public class LimsRoles:IMemberRoleProvider
    {
        [RoleMember("实验室管理员","对实验室所有业务均具有管理权限",0)]
        public const string Manager = "126D20A0-C426-437C-B808-BBA8DB269079";

        [RoleMember("业务员", "负责业务受理", 0)]
        public const string LimsBusinesser = "99526FD4-7F9D-4814-938C-82F9343946E7";

        [RoleMember("合同评审员", "对业务受理数据进行评审", 0)]
        public const string ContractReviewer = "326FAB64-AD05-4971-B9B7-0644D4DDFEE5";

        [RoleMember("分派员", "对报告中所有的检测项目进行分组，安排任务至各检测组", 0)]
        public const string Assigner = "9B56C205-04F9-42C1-87DD-F07E4DC28860";

        [RoleMember("检验管理员", "管理当前报告内所有的检测项目信息", 0)]
        public const string InspectAdministrator = "0097112F-474A-4B16-A060-2ABE3DF4BE4D";

        [RoleMember("检验员", "对报告中的检测项目进行数据录入和数据复核", 0)]
        public const string Inspector = "101A88A8-7EBF-47F4-974B-CB8E6F616DA6";

        [RoleMember("编制人", "对报告内容及检测数据进行编制，生成电子文档，调整数据格式", 0)]
        public const string Preparer = "6F62FE01-E0D5-4A27-8ABF-F118BFEA807C";

        [RoleMember("审核人", "对报告内容进行审核", 0)]
        public const string Reviewer = "1CF93FBE-F553-4A8E-ADF9-F0C364E40790";

        [RoleMember("签发人", "负责对最终的报告进行签发", 0)]
        public const string Issuer = "BD00C812-B4B0-4A7A-88FE-3878505F5346";

        [RoleMember("打印员", "系统内置打印员", 0)]
        public const string Printor = "6AF0FD59-D9A2-40D6-9954-A27CB2C19E2D";
    }
}
